﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
'#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region
Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private fx As JFX
	Private photodialog As B4XDialog
#if B4J
	Private Pane1 As Pane
	Private ScrollPane1 As ScrollPane
#End If
#if B4A
	Private Panel1 As Panel
	Private ScrollView1 As ScrollView
#End If
	Private ivphotodialog As ImageView
End Sub
Public Sub Initialize
	B4XPages.GetManager.LogEvents = True
End Sub
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	B4XPages.SetTitle(Me,"Buttons grid")
	photodialog.Initialize(Root)
	photodialog.PutAtTop = True
	photodialog.BackgroundColor = xui.Color_White
#if B4J
	set_grid(99,50,50,5)
#End If
#if B4A
	Dim scale As Int = GetDeviceLayoutValues.Scale
	Dim tabletsize As Int = GetDeviceLayoutValues.ApproximateScreenSize
	If tabletsize >= 8 Then
		scale = 2
	End If
	set_grid(99,50dip*scale,50dip*scale,5dip)
	Panel1.RemoveView
	ScrollView1.Panel.AddView(Panel1,0dip,0dip,ScrollView1.Width,Panel1.Height)
	ScrollView1.Panel.Height = Panel1.Height
#End If
End Sub
Private Sub B4XPage_Resize (Width As Int, Height As Int)
#if B4J
	set_grid(99,50,50,5)
	ScrollPane1.InnerNode = Pane1
#End If
End Sub
Private Sub set_grid(cnt As Int, Width As Int, Height As Int, gap As Int)
#if B4J
	Pane1.RemoveAllNodes
#End If
#if B4A
	Panel1.RemoveAllViews
#End If
	Dim rowpos As Int = gap
	Dim colpos As Int = gap
	For i = 0 To cnt
		' set grid item to button, label, panel or imageview (uncomment to test)
'		Dim vw As Button = set_button_item(i,Width,Height,gap)
'		Dim vw As Label = set_label_item(i,Width,Height,gap)
		Dim vw As ImageView = set_image_item(i,Width,Height,gap)
#if B4A
'		Dim vw As Panel = set_panel_item(i,Width,Height,gap)
		Panel1.AddView(vw,colpos,rowpos,Width,Height)
#End If
#if B4J
'		Dim vw As Pane = set_panel_item(i,Width,Height,gap)
		Pane1.AddNode(vw,colpos,rowpos,Width,Height)
#End If
		colpos = colpos + Width + gap
		If colpos > (Root.Width - Width) Then
			rowpos = rowpos + Height + gap
			colpos = gap
		End If
	Next
#if B4J
	Pane1.PrefHeight = rowpos + Height + gap
#End If
#if B4A
	Panel1.Height = rowpos + Height + gap
#End If
End Sub
Private Sub set_button_item(cnt As Int, width As Int, height As Int, gap As Int) As Button
	Dim btn As Button
	btn.Initialize("btn")
	btn.Text = "b" & cnt
	btn.Tag = btn.Text
#if B4J
	CSSUtils.SetBackgroundImage(btn,File.DirAssets,get_random_background_image)
	btn.Alignment = "BOTTOM_CENTER"
	btn.prefWidth = width
	btn.PrefHeight = height
#End If
#if B4A
	btn.SetBackgroundImage(LoadBitmap(File.DirAssets,get_random_background_image))
	btn.Gravity = Gravity.BOTTOM
	btn.Width = width
	btn.Height = height
#End If
	Return btn
End Sub
Private Sub set_label_item(cnt As Int, width As Int, height As Int, gap As Int) As Label
	Dim lbl As Label
	lbl.Initialize("lbl")
	lbl.Text = "L" & cnt
	lbl.Tag = lbl.Text
#if B4J
	CSSUtils.SetBackgroundImage(lbl,File.DirAssets,get_random_background_image)
	lbl.Alignment = "BOTTOM_CENTER"
	lbl.prefWidth = width
	lbl.PrefHeight = height
#End If
#if B4A
	lbl.SetBackgroundImage(LoadBitmap(File.DirAssets,get_random_background_image))
	lbl.Gravity = Gravity.BOTTOM
	lbl.Width = width
	lbl.Height = height
#End If
	Return lbl
End Sub
Private Sub set_panel_item(cnt As Int, width As Int, height As Int, gap As Int) As B4XView
#if B4A
	Dim pnl As Panel
#End If
#if B4J
	Dim pnl As Pane
#End If
	pnl.Initialize("pnl")
	pnl.Tag = "P" & cnt
#if B4J
'	CSSUtils.SetBackgroundImage(pnl,File.DirAssets,get_random_background_image)
	Dim clr As Int = get_random_color
	CSSUtils.SetBackgroundColor(pnl,fx.Colors.From32Bit(clr))
	pnl.prefWidth = width
	pnl.PrefHeight = height
#End If
#if B4A
'	pnl.SetBackgroundImage(LoadBitmap(File.DirAssets,get_random_background_image))
	Dim clr As Int = get_random_color
	pnl.Color = clr
	pnl.Width = width
	pnl.Height = height
#End If
	Dim lbl As Label
	lbl.Initialize("")
	lbl.Text = "P" & cnt
#if B4A
	lbl.Height = 20dip
	lbl.Typeface = Typeface.DEFAULT_BOLD
	lbl.TextColor = ContrastColor(clr)
	pnl.AddView(lbl,10dip,(height/2),width-10dip,lbl.Height)
#End If
#if B4J
	lbl.prefHeight = 20dip
	lbl.TextColor = fx.Colors.From32Bit(ContrastColor(clr))
	pnl.AddNode(lbl,10dip,(height/2),width-10dip,lbl.Height)
#End If
	Return pnl
End Sub
Private Sub set_image_item(cnt As Int, width As Int, height As Int, gap As Int) As ImageView
	Dim img As ImageView
	img.Initialize("img")
	img.Tag = get_random_image_thumbnail
#if B4A
'	img.Tag = get_random_image_thumbnail
	img.Bitmap = LoadBitmapResize(File.DirAssets,img.tag,width,height,True)
	img.Width = width
	img.Height = height
#End If
#if B4J
	Dim im As Image
	im.Initialize(File.DirAssets,img.tag)
	img.SetImage(im)
	img.prefWidth = width
	img.PrefHeight = height
#End If
	Return img
End Sub
#region events
Private Sub btn_Click
	Dim btn As Button = Sender
	Log("btn " & btn.Tag & " clicked")
End Sub
#if B4A
Private Sub lbl_Click
	Dim lbl As Label = Sender
	Log("lbl " & lbl.Tag & " clicked")
End Sub
#End If
#if B4J
Private Sub lbl_MouseClicked (EventData As MouseEvent)
	Dim lbl As Label = Sender
	Log("lbl " & lbl.Tag & " clicked")
End Sub
#End If
#if B4A
Private Sub pnl_Click
	Dim pnl As Panel = Sender
	Log("pnl " & pnl.Tag & " clicked")
End Sub
#End If
#if B4J
Private Sub pnl_MouseClicked (EventData As MouseEvent)
	Dim pnl As Pane = Sender
	Log("pnl " & pnl.Tag & " clicked")
End Sub
#End If
#if B4A
Private Sub img_Click
	Dim img As ImageView = Sender
	Log("img " & img.Tag & " clicked")
	Dim pnl As B4XView = xui.CreatePanel("")
	Dim devwidth As Int = GetDeviceLayoutValues.Width
	Dim devheight As Int = GetDeviceLayoutValues.height
	pnl.SetLayoutAnimated(0dip, 0dip, 0dip,devwidth-20dip,devheight-130dip)
	img.Bitmap = LoadBitmapResize(File.DirAssets,img.tag,width,height,True)
	pnl.LoadLayout("photodialog_layout")
	Dim rsub1 As ResumableSub =  photodialog.ShowCustom(pnl, "OK", "", "")
	Wait For (rsub1) Complete (Result As Int)
	If Result = xui.dialogResponse_Positive Then
		'
	End If
End Sub
#End If
#if B4J
Private Sub img_MouseClicked (EventData As MouseEvent)
	Dim img As ImageView = Sender
	Log("img " & img.Tag & " clicked")
	Dim pnl As B4XView = xui.CreatePanel("")
	pnl.LoadLayout("photodialog_layout")
	Dim im As Image
	im.Initialize(File.DirAssets,img.tag)
	ivphotodialog.SetImage(im)
	ivphotodialog.PreserveRatio = True
	pnl.SetLayoutAnimated(0,0,0,ivphotodialog.Width,ivphotodialog.Height-150)
	Dim rsub1 As ResumableSub =  photodialog.ShowCustom(pnl, "OK", "", "")
	Wait For (rsub1) Complete (Result As Int)
	If Result = xui.dialogResponse_Positive Then
		'
	End If
End Sub
#End If
#End Region
#region functions
Private Sub get_random_image_thumbnail As String
	Dim lst As List = Array As String ("beautiful_place_01.jpg","beautiful_place_02.jpg","beautiful_place_04.jpg","beautiful_place_05.jpg", _
						"beautiful_place_06.jpg","beautiful_place_07.jpg","beautiful_place_11.jpg","beautiful_place_12.jpg","beautiful_place_15.jpg", _
						"beautiful_place_23.jpg","")
	Dim num As Int = Rnd(0,10)
	Dim fname As String = lst.Get(num)
	If fname = "" Then fname = lst.Get(0)
	Return fname
End Sub
Private Sub get_random_background_image As String
	Dim lst As List = Array As String ("add.png","back.png","calendar.png","category.png", _
						"clear.png","closetab.png","code.png","columns.png","delete.png", _
						"download.png","")
	Dim num As Int = Rnd(0,10)
	Dim fname As String = lst.Get(num)
	If fname = "" Then fname = lst.Get(0)
	Return fname
End Sub
Private Sub get_random_color As Int
	Dim RGB As List
	RGB.Initialize
	RGB.Add(Rnd(0,255))
	RGB.Add(Rnd(0,255))
	RGB.Add(Rnd(0,255))
	Dim color As Int = xui.Color_RGB(RGB.Get(0),RGB.Get(1),RGB.Get(2))
	Return color
End Sub
Public Sub ContrastColor(Color As Int) As Int
	Dim lum As Double = 1 - (0.299 * Bit.And(Bit.ShiftRight(Color,16),0xFF) + 0.587 * Bit.And(Bit.ShiftRight(Color,8),0XFF) + 0.114 * Bit.And(Color,0xFF)) / 255
	If lum < 0.5 Then
		Return xui.Color_Black
	Else
		Return xui.Color_White
	End If
End Sub
#End Region
